import { useCssVars as K, ref as h, computed as d, watch as w, onMounted as Y, openBlock as c, createElementBlock as v, createElementVNode as n, normalizeStyle as b, createVNode as ee, renderSlot as te, createCommentVNode as k, unref as le, Fragment as P, renderList as z, withDirectives as E, vModelText as A, toDisplayString as R, pushScopeId as ae, popScopeId as ie } from "vue";
import ne from "./BaseIcon-D2n64yMC.js";
import { t as oe, u as ue } from "./useResponsive-NZB-WLRF.js";
import { c as re, Q as V, P as B, X as se } from "./index-CP7GYbDW.js";
import { _ as de } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const O = (l) => (ae("data-v-1029266f"), l = l(), ie(), l), me = {
  "data-html2canvas-ignore": "",
  style: { padding: "0 24px" }
}, ce = {
  class: "vue-data-ui-slicer-labels",
  style: { position: "relative", "z-index": "1", "pointer-events": "none" }
}, ve = {
  key: 0,
  style: { width: "100%", position: "relative" }
}, he = {
  key: 0,
  class: "minimap",
  style: { width: "100%" }
}, pe = ["xmlns", "viewBox"], fe = ["id"], ye = ["stop-color"], ge = /* @__PURE__ */ O(() => /* @__PURE__ */ n("stop", {
  offset: "100%",
  "stop-color": "transparent"
}, null, -1)), xe = ["d", "stroke"], be = ["x", "width", "height", "fill", "rx"], Se = ["d", "fill"], ke = ["x", "width", "height", "fill"], Ce = ["cx", "cy", "stroke", "fill"], Ne = ["cx", "cy", "stroke", "fill"], we = ["x1", "x2", "y2", "stroke"], $e = ["x", "height", "width", "onMouseenter"], Ie = /* @__PURE__ */ O(() => /* @__PURE__ */ n("div", { class: "slider-track" }, null, -1)), Fe = ["min", "max"], Le = ["min", "max"], Me = {
  __name: "Slicer",
  props: {
    background: {
      type: String,
      default: "#FFFFFF"
    },
    borderColor: {
      type: String,
      default: "#FFFFFF"
    },
    fontSize: {
      type: Number,
      default: 14
    },
    labelLeft: {
      type: String,
      default: ""
    },
    labelRight: {
      type: String,
      default: ""
    },
    textColor: {
      type: String,
      default: "#1A1A1A"
    },
    inputColor: {
      type: String,
      default: "#1A1A1A"
    },
    max: {
      type: Number,
      default: 0
    },
    min: {
      type: Number,
      default: 0
    },
    selectColor: {
      type: String,
      default: "#4A4A4A"
    },
    useResetSlot: {
      type: Boolean,
      default: !1
    },
    valueStart: {
      type: [Number, String],
      default: 0
    },
    valueEnd: {
      type: [Number, String],
      default: 0
    },
    minimap: {
      type: Array,
      default: []
    },
    smoothMinimap: {
      type: Boolean,
      default: !1
    },
    minimapSelectedColor: {
      type: String,
      default: "#1f77b4"
    },
    minimapSelectionRadius: {
      type: Number,
      default: 12
    },
    minimapLineColor: {
      type: String,
      default: "#2D353C"
    },
    minimapSelectedColorOpacity: {
      type: Number,
      default: 0.2
    },
    minimapSelectedIndex: {
      type: Number,
      default: null
    },
    minimapIndicatorColor: {
      type: String,
      default: "#2D353C"
    }
  },
  emits: ["update:start", "update:end", "reset", "trapMouse"],
  setup(l, { emit: y }) {
    const e = l;
    K((t) => ({
      "3450fc53": T.value,
      "6772f672": S.value,
      "31c3be10": W.value,
      a7087412: l.selectColor,
      "584345f6": U.value
    }));
    const u = h(e.min), r = h(e.max), g = d(() => !!e.minimap.length), $ = h(re()), D = d(() => {
      const t = e.max - e.min, a = (u.value - e.min) / t * 100, o = (r.value - e.min) / t * 100;
      return {
        left: `${a}%`,
        width: `${o - a}%`,
        background: e.selectColor
      };
    }), T = d(() => e.inputColor), U = d(() => e.background), W = d(() => `${e.selectColor}33`), S = d(() => e.borderColor), I = d(() => {
      let t = [];
      for (let a = 0; a < e.minimap.length; a += 1)
        t.push(a);
      return t;
    });
    function F() {
      y("reset");
    }
    function X() {
      Number(u.value) > Number(r.value) - 1 && (u.value = Number(r.value) - 1), y("update:start", Number(u.value));
    }
    function j() {
      Number(r.value) < Number(u.value) + 1 && (r.value = Number(u.value) + 1), y("update:end", Number(r.value));
    }
    w(
      () => e.min,
      (t) => {
        Number(u.value) < Number(t) && (u.value = Number(t)), Number(r.value) < Number(t) && (r.value = Number(t));
      }
    ), w(
      () => e.max,
      (t) => {
        Number(u.value) > Number(t) && (u.value = Number(t)), Number(r.value) > Number(t) && (r.value = Number(t));
      }
    );
    const C = h(null), i = h({
      width: 1,
      height: 1
    }), L = h(null);
    Y(() => {
      if (g.value) {
        const t = oe(() => {
          const { width: a, height: o } = ue({
            chart: C.value
          });
          i.value.width = a, i.value.height = o - 47;
        });
        L.value = new ResizeObserver(t), L.value.observe(C.value);
      }
    });
    const s = d(() => e.minimap.length ? i.value.width / e.minimap.length : 0), p = d(() => {
      if (!e.minimap.length) return [];
      const t = Math.max(...e.minimap), a = Math.min(...e.minimap) - 10, o = t - (a > 0 ? 0 : a), m = e.minimap.map((_, H) => {
        const J = _ - a;
        return {
          x: i.value.width / e.minimap.length * H + s.value / 2,
          y: i.value.height - J / o * (i.value.height * 0.9)
        };
      }), N = e.smoothMinimap ? V(m) : B(m), M = [...m].slice(e.valueStart, e.valueEnd), Z = e.smoothMinimap ? V(M) : B(M);
      return {
        fullSet: N,
        selectionSet: Z,
        firstPlot: m[e.valueStart],
        lastPlot: m[e.valueEnd - 1]
      };
    }), f = d(() => ({
      x: s.value * u.value + s.value / 2,
      width: i.value.width * ((r.value - u.value) / e.max) - s.value
    })), q = d(() => ({
      left: 0,
      color: e.textColor,
      fontSize: `${e.fontSize}px`,
      top: g.value ? "28px" : "-28px",
      pointerEvents: "none"
    })), G = d(() => ({
      right: 0,
      color: e.textColor,
      fontSize: `${e.fontSize}px`,
      top: g.value ? "28px" : "-28px",
      direction: "rtl",
      pointerEvents: "none"
    })), x = h(e.minimapSelectedIndex);
    w(() => e.minimapSelectedIndex, (t) => {
      x.value = t + e.valueStart;
    }, { immediate: !0 });
    function Q(t) {
      x.value = t, t >= e.valueStart && t < e.valueEnd && y("trapMouse", t - e.valueStart);
    }
    return (t, a) => (c(), v("div", me, [
      n("div", ce, [
        l.valueStart > 0 || l.valueEnd < l.max ? (c(), v("div", ve, [
          l.useResetSlot ? te(t.$slots, "reset-action", {
            key: 1,
            reset: F
          }, void 0, !0) : (c(), v("button", {
            key: 0,
            "data-cy-reset": "",
            tabindex: "0",
            role: "button",
            class: "vue-data-ui-refresh-button",
            style: b({
              top: g.value ? "36px" : "-16px",
              pointerEvents: "all !important"
            }),
            onClick: F
          }, [
            ee(ne, {
              name: "refresh",
              stroke: l.textColor
            }, null, 8, ["stroke"])
          ], 4))
        ])) : k("", !0)
      ]),
      n("div", {
        class: "double-range-slider",
        ref_key: "minimapWrapper",
        ref: C,
        style: { "z-index": "0" }
      }, [
        g.value ? (c(), v("div", he, [
          (c(), v("svg", {
            xmlns: le(se),
            viewBox: `0 0 ${i.value.width < 0 ? 0 : i.value.width} ${i.value.height < 0 ? 0 : i.value.height}`
          }, [
            n("defs", null, [
              n("linearGradient", {
                id: $.value,
                x1: "0%",
                y1: "0%",
                x2: "0%",
                y2: "100%"
              }, [
                n("stop", {
                  offset: "0%",
                  "stop-color": `${l.minimapLineColor}50`
                }, null, 8, ye),
                ge
              ], 8, fe)
            ]),
            n("path", {
              d: `M${p.value.fullSet}`,
              stroke: `${l.minimapLineColor}`,
              fill: "none",
              "stroke-width": "1",
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              style: { opacity: "1" }
            }, null, 8, xe),
            n("rect", {
              x: f.value.x,
              width: f.value.width < 0 ? 0 : f.value.width,
              height: i.value.height,
              y: 0,
              fill: S.value,
              rx: l.minimapSelectionRadius,
              stroke: "none"
            }, null, 8, be),
            n("path", {
              d: `M${s.value / 2},${i.value.height} ${p.value.fullSet} L${i.value.width - s.value / 2},${i.value.height}Z`,
              fill: `url(#${$.value})`,
              stroke: "none",
              style: { opacity: "1" }
            }, null, 8, Se),
            n("rect", {
              x: f.value.x,
              width: f.value.width < 0 ? 0 : f.value.width,
              height: i.value.height,
              y: 0,
              fill: l.minimapSelectedColor,
              style: b({
                opacity: l.minimapSelectedColorOpacity
              })
            }, null, 12, ke),
            n("circle", {
              cx: p.value.firstPlot.x,
              cy: p.value.firstPlot.y,
              "stroke-width": "0.5",
              stroke: S.value,
              r: "3",
              fill: l.minimapLineColor
            }, null, 8, Ce),
            n("circle", {
              cx: p.value.lastPlot.x,
              cy: p.value.lastPlot.y,
              "stroke-width": "0.5",
              stroke: S.value,
              r: "3",
              fill: l.minimapLineColor
            }, null, 8, Ne),
            x.value !== null ? (c(!0), v(P, { key: 0 }, z(I.value, (o, m) => (c(), v("g", null, [
              x.value === o && o >= l.valueStart && o < l.valueEnd ? (c(), v("line", {
                key: 0,
                x1: s.value * m + s.value / 2,
                x2: s.value * m + s.value / 2,
                y1: 0,
                y2: i.value.height,
                stroke: l.minimapIndicatorColor,
                "stroke-linecap": "round",
                "stroke-dasharray": "2",
                "stroke-width": "1"
              }, null, 8, we)) : k("", !0)
            ]))), 256)) : k("", !0),
            (c(!0), v(P, null, z(I.value, (o, m) => (c(), v("rect", {
              x: s.value * m,
              y: 0,
              height: i.value.height,
              width: s.value,
              fill: "transparent",
              style: { "pointer-events": "all !important" },
              onMouseenter: (N) => Q(o),
              onMouseleave: a[0] || (a[0] = (N) => {
                x.value = null, y("trapMouse", null);
              })
            }, null, 40, $e))), 256))
          ], 8, pe))
        ])) : k("", !0),
        Ie,
        n("div", {
          class: "range-highlight",
          style: b(D.value)
        }, null, 4),
        E(n("input", {
          type: "range",
          class: "range-left",
          min: l.min,
          max: l.max,
          "onUpdate:modelValue": a[1] || (a[1] = (o) => u.value = o),
          onInput: X
        }, null, 40, Fe), [
          [A, u.value]
        ]),
        n("div", {
          class: "thumb-label thumb-label-left",
          style: b(q.value)
        }, R(l.labelLeft), 5),
        E(n("input", {
          type: "range",
          class: "range-right",
          min: l.min,
          max: l.max,
          "onUpdate:modelValue": a[2] || (a[2] = (o) => r.value = o),
          onInput: j
        }, null, 40, Le), [
          [A, r.value]
        ]),
        n("div", {
          class: "thumb-label thumb-label-right",
          style: b(G.value)
        }, R(l.labelRight), 5)
      ], 512)
    ]));
  }
}, Ve = /* @__PURE__ */ de(Me, [["__scopeId", "data-v-1029266f"]]);
export {
  Ve as S
};
